#include "task.h"
#include "applicationicon.h"
#include "menu.h"
#include "wimp_error.h"

using namespace rov2;

namespace tutorial3
{
/* We can create a class like this... */
static CTask* pTask = new CTask("Third ROVLib2 app!");

/*! Defines my own menu */
class MyMenu : public CMenu
{
public:
  MyMenu() : CMenu("ROVLib2", 2)
  {
    m_miQuit = new CTextMenuItem("Quit");
    AddItem(m_miQuit);
  }

  eMenuHandled Clicked(const unsigned int* kuiaEntries)
  {
    switch (kuiaEntries[0])
    {
    case 0: // First menu item
      pTask->Stop();
      return mhHandledClose;
    }

    return mhUnhandled;
  }

private:
  CMenuItem* m_miQuit;
};

/*! Defines my own application icon */
class MyIcon : public CApplicationIcon
{
public:
  /*! We are going to use the "!system" sprite for our icon */
  MyIcon() : CApplicationIcon("!system")
  {
    m_mMyMenu = new MyMenu();
  }

  /*! Not much in the destructor! */
  ~MyIcon() {}

  bool Clicked(const tMouseClickBlock& rkmcbClickBlock)
  {
    if (rkmcbClickBlock.bcButtons.menu)
    {
      m_mMyMenu->DisplayAsIconbarMenu();
    }
    return true;
  }

private:
  CMenu* m_mMyMenu;
};
}

using namespace tutorial3;

int main(int argc, char** argv)
{
  /* Create our application icon */
  MyIcon* pIcon = new MyIcon();

  /* Poll until we want to stop*/
  pTask->Poll();

  /* Delete everything */
  delete(pIcon);

  return 0;
}
